-- Amr Sabry and Zena Ariola
-- Jan 2005

-- lambda-db and its compilation to an abstract instruction set

module AI (
  DB(..), I(..),
  compile
) where

-------------------------------------------------------------------

data DB = DBvar Int | DBlam DB | DBapp DB DB 

data I = Exec
       | Clear I
       | Closure I I
       | Pusharg I
       | Poparg I
       | Extendenv I
       | Lookupenv I
  deriving Show

compile :: DB -> I
compile (DBvar 0) = Lookupenv $ Exec
compile (DBvar n) = Lookupenv $ Clear $ compile (DBvar (n-1))
compile (DBlam t) = Poparg $ Extendenv $ (compile t)
compile (DBapp t1 t2) = Closure (compile t2) $ Pusharg $ (compile t1)


-------------------------------------------------------------------

