-- Amr Sabry and Zena Ariola
-- Jan 2005

module Main where

import L
import AI
import qualified NameL
import qualified ValueL
import qualified NameAM
import qualified ValueAM

------------------------------------------------------------------------

varz = DBvar 0
app e1 e2 = DBapp e1 e2
lam e = DBlam e

t0 = varz
t1 = lam varz
t2 = app (lam varz) t0
t3 = app (lam varz) (lam varz)
t4 = app t3 t3
t5 = app t4 (app t4 t3)
t6 = app t5 (app t5 (app t4 t3))

td :: (C -> (Int,C)) -> (I -> (Int,C)) -> (I -> C) -> DB -> IO ()
td evl evm emb t = 
    let is = compile t
        (ms,ma) = evm is
        (cs,ca) = evl (emb is)
    in seq ms $ seq cs $
       do putStr ("\n--------------------------------\n" ++
                  "Answer using abstract machine: " ++ 
                  "(" ++ show ms ++ " steps)\n")
          print ma
          putStr ("Answer using calculus: " ++ 
                  "(" ++ show cs ++ " steps)\n")
          print ca

tn = td NameL.eval NameAM.eval NameAM.embedI
tv = td ValueL.eval ValueAM.eval ValueAM.embedI

------------------------------------------------------------------------

