-- Amr Sabry and Zena Ariola
-- Jan 2005

module NameL (
  eval
) where

import L
import Monad
import Debug.Trace

------------------------------------------------------------------------
-- Stepping

step :: C -> Maybe C
step (v `Bar` e) = 
    -- Try to simplify the context and the context
    (do e' <- rede e; return $ v `Bar` e')
    `mplus`
    (do v' <- redv v; return $ v' `Bar` e)
    -- Look at context
    `mplus`
    (case e of 
      Mub c' -> Just $ c' `Csub` (Sacc v)
     -- Need to make progress with the term
      e -> case (v,e) of
             (Lam bv, v' `Cons` e') -> 
               Just $ v' `Bar` (Mub (bv `Bar` (e' `Eweak` Wacc)))
             (Mustack c',e) -> Just $ c' `Csub` (Sstack e)
             (Muenv c',e) -> Just $ c' `Csub` (Senv e)
             _ -> Nothing)
step c = redc c

------------------------------------------------------------------------
-- Evaluation

eval :: C -> (Int,C)
eval c = loop 0 (c 
                 `Csub` 
                 (Senv (Tp `Eweak` Wstack)) 
                 `Csub` 
                 (Sstack Tp))
    where loop i c = 
              trace ("\n" ++ show c ++ "\n") $ 
              case step c of 
                Nothing -> (i,c)
                Just c' -> loop (i+1) c'

------------------------------------------------------------------------
